# Process the files obtaining with rapidminer
import csv
from Constants import *
from cpHydra import *


def elaborate_files(file_name):
    reader_3C = csv.reader(open(PRED_FILES_PATH + file_name + "_3C", "rb"), delimiter=';')
    reader_max = csv.reader(open(PRED_FILES_PATH + file_name + "_max", "rb"), delimiter=';')
    reader_avg = csv.reader(open(PRED_FILES_PATH + file_name + "_avg", "rb"), delimiter=';')
    reader_stdv = csv.reader(open(PRED_FILES_PATH + file_name + "_stdv", "rb"), delimiter=';')
    reader_fsC = csv.reader(open(PRED_FILES_PATH + file_name + "_fs", "rb"), delimiter=';')
    reader_mistralC = csv.reader(open(PRED_FILES_PATH + file_name + "_mistralC", "rb"), delimiter=';')
    reader_regft = csv.reader(open(PRED_FILES_PATH + file_name + "_regft", "rb"), delimiter=';')
    reader_test = csv.reader(open(TEST_FILES_PATH + file_name, "rb"), delimiter=';')
    reader_regMistral = csv.reader(open(PRED_FILES_PATH + file_name + '_regMistral', "rb"), delimiter=';')
    reader_regChoco = csv.reader(open(PRED_FILES_PATH + file_name + '_regChoco', "rb"), delimiter=';')
    reader_regAbscon = csv.reader(open(PRED_FILES_PATH + file_name + '_regAbscon', "rb"), delimiter=';')

    reader_train = csv.reader(open(TRAIN_FILES_PATH + file_name, "rb"), delimiter=';')

    output_file = open(PRED_FILES_PATH + file_name + "_all", "wb" )
    writer_all = csv.writer(output_file)

    cases = Casebase()
    cases.addFromFile(TRAIN_FILES_PATH + file_name)

    writer_all.writerow([
        "3C",
        "max",
        "avg",
        "stdv",
        "fsC",
        "mistralC",
        "regft",
        "ft",
        "mistral",
        "choco",
        "abscon",
        "cpHydra",
        "regMistral",
        "regChoco",
        "regAbscon"
        ])

    row_number = 0
    for row_test in reader_test:
        if row_number != 0:
            writer_all.writerow([
                reader_3C.next()[4],
                reader_max.next()[3],
                reader_avg.next()[4],
                reader_stdv.next()[3],
                reader_fsC.next()[4],
                reader_mistralC.next()[4],
                reader_regft.next()[1],
                row_test[-3],
                row_test[-7],
                row_test[-8],
                row_test[-9],
                get_cpHydra_time(row_test,cases),
                reader_regMistral.next()[1],
                reader_regChoco.next()[1],
                reader_regAbscon.next()[1]
                ])
        else:
            reader_3C.next()
            reader_max.next()
            reader_avg.next()
            reader_stdv.next()
            reader_fsC.next()
            reader_mistralC.next()
            reader_regft.next()
            reader_regMistral.next()
            reader_regChoco.next()
            reader_regAbscon.next()
            row_number += 1
    output_file.close()