from Schedule import *

class TesterSatzilla(Schedule):
    """
    TesterSatzilla(file_name, sorting function)

    solve the jobs using a FIFO strategy and using only the solver having the
    minimus expected solving time
    """

    def __init__(self,*args):
        super(TesterSatzilla,self).__init__(args[0],args[1])
            
    def create_jobs(self):
        self.current_job = 0
        
    def getjob(self,client):
        if self.current_job < len(self.instances):
            job = self.current_job
            self.current_job += 1
            solver = self.instances[job].get_satzilla_solver_order().pop(0)
            return (job,solver,TIMEOUT)
        else:
            return (NO_JOB,"",TIMEOUT)